<?php


class BirdsmeterShortcode
{
    public function __construct()
    {
        add_shortcode( 'birdsmeter',array($this,'birdsmeter_shortcode_cb'));
    }

    function birdsmeter_shortcode_cb($atts){
        $atts = (shortcode_atts(
            array(
                'campaign' => '',
                'currency' => '',
                'target' => '',
                'raised' => '',
                'number_format' => '',
                'fill_color' =>'',
                'size' =>'',
                'target_text_color' =>'',
                'raised_text_color' =>'',
                'show_target' =>'',
                'show_raised' => '',
            ), $atts));
        $therm_defaults = Birdsmeter::$therm_defaults;
        $options = wp_parse_args( get_option('birdsmeter_options',$therm_defaults), $therm_defaults);
        $therm_properties = array();

        //campaign
        if (empty($atts['campaign'])){
            $therm_properties['campaign'] = $options['campaign'];
        }
        else{
            $therm_properties['campaign'] = $atts['campaign'];
        }
        //currency
        if (empty($atts['currency'])){
            $therm_properties['currency'] = $options['currency'];
        }
        else{
            $therm_properties['currency'] = $atts['currency'];
        }

        //target
        if (empty($atts['target'])){
            $therm_properties['target'] = $options['target'];
        }
        else{
            $therm_properties['target'] = $atts['target'];
        }

        //raised
        if (empty($atts['raised'])){
            $therm_properties['raised'] = $options['raised'];
        }
        else{
            $therm_properties['raised'] = $atts['raised'];
        }

        //number format
        if (empty($atts['number_format'])){
            $therm_properties['number_format'] = $options['number_format'];
        }
        else{
            $therm_properties['number_format'] = $atts['number_format'];
        }

        //fill color
        if (empty($atts['fill_color'])){
            $therm_properties['fill_color'] = $options['fill_color'];
        }
        else{
            $therm_properties['fill_color'] = $atts['fill_color'];
        }

        //size
        if (empty($atts['size'])){
            $therm_properties['size'] = $options['size'];
        }
        else{
            $therm_properties['size'] = $atts['size'];
        }

        //target_text_color
        if (empty($atts['target_text_color'])){
            $therm_properties['target_text_color'] = $options['target_text_color'];
        }
        else{
            $therm_properties['target_text_color'] = $atts['target_text_color'];
        }

        //raised_text_color
        if (empty($atts['raised_text_color'])){
            $therm_properties['raised_text_color'] = $options['raised_text_color'];
        }
        else{
            $therm_properties['raised_text_color'] = $atts['raised_text_color'];
        }

        //show_target
        if (empty($atts['show_target'])){
            $therm_properties['show_target'] = $options['show_target']?$options['show_target']:0;
        }
        else{
            $therm_properties['show_target'] = $atts['show_target'];
        }

        //show_raised
        if (empty($atts['show_raised'])){
            $therm_properties['show_raised'] = $options['show_raised']?$options['show_raised']:0;
        }
        else{
            $therm_properties['show_raised'] = $atts['show_raised'];
        }

        return $this->thermhtml($therm_properties);
    }

    function thermhtml($therm_properties)
    {
        ob_start();
        $therm_default_style = Birdsmeter::$therm_default_style;
        $options_css = wp_parse_args( get_option('birdsmeter_style',$therm_default_style), $therm_default_style);
        echo '<style type="text/css">
	.thermometer_target{'.$options_css['target_style'].'}
	.thermometer_raised{'.$options_css['raised_style'].'}
	.thermometer_campaign{'.$options_css['campaign_style'].'}
	</style>';

        $therm_properties['remove_link'] = $options_css['remove_link']?$options_css['remove_link']:0;


        $size = $therm_properties['size'];
        if ($size == 'large') {
            $width = '373';
            $height = '446';
        }
        elseif ($size == 'medium'){
            $width = '298';
            $height = '356';
        }
        elseif ($size == 'small'){
            $width = '224';
            $height = '268';
        }

        /*
         * svg start
         */
        echo '<div style="display: inline-block; width: ' . $width . 'px; position: relative; user-select: none;">';
        if (!$therm_properties['remove_link']){
            echo '<a href="https://www.couponbirds.com/fundraising-thermometer" target="_blank">';
        }
        echo '<canvas height="' . $height . '" width="' . $width . '" style="display: block; width: 100%!important; visibility: hidden;"></canvas>';
        echo '<svg width="' . $width . '" height="' . $height . '" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 373 446" version="1.1" style="height: 100%; left: 0; position: absolute; top: 0; width: 100%;" >';
        echo '<style>text{font:normal 20px sans-serif;}</style>';
        echo '<defs>';
        echo '<circle id="path-1" cx="41.5" cy="343.085289" r="41.5"></circle>';
        echo '<filter x="-3.6%" y="-3.6%" width="107.2%" height="107.2%" filterUnits="objectBoundingBox" id="filter-2">
            <feMorphology radius="2" operator="erode" in="SourceAlpha" result="shadowSpreadInner1"></feMorphology>
            <feGaussianBlur stdDeviation="2" in="shadowSpreadInner1" result="shadowBlurInner1"></feGaussianBlur>
            <feOffset dx="0" dy="0" in="shadowBlurInner1" result="shadowOffsetInner1"></feOffset>
            <feComposite in="shadowOffsetInner1" in2="SourceAlpha" operator="arithmetic" k2="-1" k3="1" result="shadowInnerInner1"></feComposite>
            <feColorMatrix values="0 0 0 0 0.693585824   0 0 0 0 0.693585824   0 0 0 0 0.693585824  0 0 0 0.5 0" type="matrix" in="shadowInnerInner1"></feColorMatrix>
        </filter>';
        echo '<linearGradient x1="0%" y1="52.9782618%" x2="100%" y2="52.9782618%" id="linearGradient-3">
            <stop stop-color="#D9D9D9" offset="0%"></stop>
            <stop stop-color="#FFFFFF" offset="22.331609%"></stop>
            <stop stop-color="#FFFFFF" offset="59.0002111%"></stop>
            <stop stop-color="#CECECE" offset="100%"></stop>
        </linearGradient>';

        //mercury gradient color
        $mercury_gradient_color = $this->thermometer_generate_mercury_gradient($therm_properties['fill_color']);
        echo '<linearGradient x1="-9.59312193%" y1="42.7217643%" x2="88.9260237%" y2="42.7217643%" id="linearGradient-4">
            <stop stop-color="'.$mercury_gradient_color['first'] .'" offset="0%"></stop>
            <stop stop-color="'.$mercury_gradient_color['second'] .'" offset="39.7091427%"></stop>
            <stop stop-color="'.$mercury_gradient_color['third'] .'" offset="100%"></stop>
        </linearGradient>';
        echo '<circle id="path-5" cx="41.5" cy="343.085289" r="32.5"></circle>';
        echo '<filter x="-6.2%" y="-6.2%" width="112.3%" height="112.3%" filterUnits="objectBoundingBox" id="filter-6">
            <feMorphology radius="2" operator="erode" in="SourceAlpha" result="shadowSpreadInner1"></feMorphology>
            <feGaussianBlur stdDeviation="2" in="shadowSpreadInner1" result="shadowBlurInner1"></feGaussianBlur>
            <feOffset dx="0" dy="-2" in="shadowBlurInner1" result="shadowOffsetInner1"></feOffset>
            <feComposite in="shadowOffsetInner1" in2="SourceAlpha" operator="arithmetic" k2="-1" k3="1" result="shadowInnerInner1"></feComposite>
            <feColorMatrix values="0 0 0 0 0.0100179392   0 0 0 0 0.139366022   0 0 0 0 0.575209466  0 0 0 0.5 0" type="matrix" in="shadowInnerInner1"></feColorMatrix>
        </filter>';

        //sphere gradient color
        $sphere_gradient_color = $this->thermometer_generate_sphere_gradient($therm_properties['fill_color']);
        echo '<radialGradient cx="50%" cy="50%" fx="50%" fy="50%" r="65.5017868%" id="radialGradient-7">
            <stop stop-color="'. $sphere_gradient_color['first'] .'" offset="0%"></stop>
            <stop stop-color="'. $sphere_gradient_color['second'] .'" stop-opacity="0" offset="100%"></stop>
        </radialGradient>';
        echo '<linearGradient x1="54.7017879%" y1="-11.0213431%" x2="50%" y2="122.486578%" id="linearGradient-8">
            <stop stop-color="#FFFFFF" stop-opacity="0" offset="0%"></stop>
            <stop stop-color="#FFFFFF" offset="50.6334459%"></stop>
            <stop stop-color="#FFFFFF" stop-opacity="0" offset="100%"></stop>
        </linearGradient>';
        echo '<filter x="-45.4%" y="-24.6%" width="190.8%" height="149.2%" filterUnits="objectBoundingBox" id="filter-9">
            <feGaussianBlur stdDeviation="1.6" in="SourceGraphic"></feGaussianBlur>
        </filter>';
        echo '<linearGradient x1="51.8273832%" y1="-11.0213431%" x2="50%" y2="122.486578%" id="linearGradient-10">
            <stop stop-color="#FFFFFF" stop-opacity="0" offset="0%"></stop>
            <stop stop-color="#FFFFFF" offset="50.6334459%"></stop>
            <stop stop-color="#FFFFFF" stop-opacity="0" offset="100%"></stop>
        </linearGradient>';
        echo '<filter x="-41.3%" y="-14.0%" width="182.7%" height="127.9%" filterUnits="objectBoundingBox" id="filter-11">
            <feGaussianBlur stdDeviation="2" in="SourceGraphic"></feGaussianBlur>
        </filter>';
        echo '<linearGradient x1="51.4372288%" y1="-11.0213431%" x2="50%" y2="122.486578%" id="linearGradient-12">
            <stop stop-color="#FFFFFF" stop-opacity="0" offset="0%"></stop>
            <stop stop-color="#FFFFFF" offset="50.6334459%"></stop>
            <stop stop-color="#FFFFFF" stop-opacity="0" offset="100%"></stop>
        </linearGradient>';
        echo '<filter x="-46.6%" y="-14.0%" width="193.2%" height="127.9%" filterUnits="objectBoundingBox" id="filter-13">
            <feGaussianBlur stdDeviation="2" in="SourceGraphic"></feGaussianBlur>
        </filter>';
        echo '<path d="M0,288 C1.27886601,288.75 5.372583,289.5 12,289.5 C18.627417,289.5 23.0399207,288.75 24,288" id="path-14"></path>';
        echo '<filter x="-12.7%" y="-140.4%" width="125.7%" height="473.7%" filterUnits="objectBoundingBox" id="filter-15">
            <feMorphology radius="1.5" operator="dilate" in="SourceAlpha" result="shadowSpreadOuter1"></feMorphology>
            <feOffset dx="0" dy="1" in="shadowSpreadOuter1" result="shadowOffsetOuter1"></feOffset>
            <feMorphology radius="1.5" operator="erode" in="SourceAlpha" result="shadowInner"></feMorphology>
            <feOffset dx="0" dy="1" in="shadowInner" result="shadowInner"></feOffset>
            <feComposite in="shadowOffsetOuter1" in2="shadowInner" operator="out" result="shadowOffsetOuter1"></feComposite>
            <feColorMatrix values="0 0 0 0 0.579738451   0 0 0 0 0.579738451   0 0 0 0 0.579738451  0 0 0 0.5 0" type="matrix" in="shadowOffsetOuter1"></feColorMatrix>
        </filter>';
        echo '<path d="M0,259.2 C1.27886601,259.95 5.372583,260.7 12,260.7 C18.627417,260.7 23.0399207,259.95 24,259.2" id="path-16"></path>';
        echo '<path d="M0,172.8 C1.27886601,173.55 5.372583,174.3 12,174.3 C18.627417,174.3 23.0399207,173.55 24,172.8" id="path-18"></path>';
        echo '<path d="M0,86.4 C1.27886601,87.15 5.372583,87.9 12,87.9 C18.627417,87.9 23.0399207,87.15 24,86.4" id="path-20"></path>';
        echo '<path d="M0,230.4 C1.27886601,231.15 5.372583,231.9 12,231.9 C18.627417,231.9 23.0399207,231.15 24,230.4" id="path-22"></path>';
        echo '<path d="M0,144 C1.27886601,144.75 5.372583,145.5 12,145.5 C18.627417,145.5 23.0399207,144.75 24,144" id="path-24"></path>';
        echo '<path d="M0,57.6 C1.27886601,58.35 5.372583,59.1 12,59.1 C18.627417,59.1 23.0399207,58.35 24,57.6" id="path-26"></path>';
        echo '<path d="M0,201.6 C1.27886601,202.35 5.372583,203.1 12,203.1 C18.627417,203.1 23.0399207,202.35 24,201.6" id="path-28"></path>';
        echo '<path d="M0,115.2 C1.27886601,115.95 5.372583,116.7 12,116.7 C18.627417,116.7 23.0399207,115.95 24,115.2" id="path-30"></path>';
        echo '<path d="M0,28.8 C1.27886601,29.55 5.372583,30.3 12,30.3 C18.627417,30.3 23.0399207,29.55 24,28.8" id="path-32"></path>';
        echo '<path d="M0,0 C1.27886601,0.75 5.372583,1.5 12,1.5 C18.627417,1.5 23.0399207,0.75 24,0" id="path-34"></path>';
        echo '</defs>';
        echo '<g stroke="none" stroke-width="1" fill="none" fill-rule="evenodd" transform="translate(145.000000, 31.000000)">';
        echo '<g id="g1">
                <use fill="#FFFFFF" fill-rule="evenodd" xlink:href="#path-1"></use>
                <use fill="black" fill-opacity="1" filter="url(#filter-2)" xlink:href="#path-1"></use>
            </g>';
        echo '<path d="M28,10.981895 C30.5008205,3.66063165 35.2636392,0 42.2884561,0 C49.3132729,0 53.8837876,3.66063165 56,10.981895 L56,315 L28,315 L28,10.981895 Z" id="p2" fill="url(#linearGradient-3)"></path>';

        //mercury
        $mercury_path = $this->thermometer_generate_mercury_path($therm_properties['target'],$therm_properties['raised']);
        echo '<path d="'. $mercury_path .'" id="p3" fill="url(#linearGradient-4)"></path>';

        //bottom sphere
        echo '<g id="g4">
                <use fill="'. $therm_properties['fill_color'] .'" fill-rule="evenodd" xlink:href="#path-5"></use>
                <use fill="black" fill-opacity="1" filter="url(#filter-6)" xlink:href="#path-5"></use>
            </g>';

        //bottom sphere effect
        echo '<circle id="c5" fill="url(#radialGradient-7)" opacity="0.616048177" cx="42" cy="340" r="21"></circle>';

        echo '<path d="M22.8089079,318.83399 L30.8089079,318.83399 C29.0934126,323.172887 28.2356649,326.485557 28.2356649,328.772001 C28.2356649,330.81889 28.5601683,334.012682 29.2091752,338.353377 L21.2091752,338.353377 C20.5601683,333.873246 20.2356649,330.540018 20.2356649,328.353692 C20.2356649,326.206685 21.0934126,323.033451 22.8089079,318.83399 Z" id="p6" fill="url(#linearGradient-8)" filter="url(#filter-9)" transform="translate(25.522286, 328.593684) rotate(36.000000) translate(-25.522286, -328.593684) "></path>';
        echo '<path d="M45.0290663,342.325993 L48.8122008,342.325993 C43.0009293,352.27039 40.0952935,359.58533 40.0952935,364.270813 C40.0952935,368.465391 43.0009293,375.477987 48.8122008,385.308602 L45.0290663,385.308602 C37.1621545,379.308933 33.6203128,372.145165 34.4035412,363.817297 C34.4035412,352.826689 37.9453829,345.662921 45.0290663,342.325993 Z" id="p7" fill="url(#linearGradient-10)" opacity="0.59891183" filter="url(#filter-11)" transform="translate(41.554683, 363.817297) rotate(-90.000000) translate(-41.554683, -363.817297) "></path>';
        echo '<path d="M66.4853049,316.011061 L69.8735672,316.011061 C63.8984897,325.819622 60.910951,333.066644 60.910951,337.752127 C60.910951,341.946704 63.5343351,348.917208 68.7811034,358.663638 L66.4853049,358.99367 C59.7714351,351.406945 56.6220775,344.09875 57.0372322,337.069085 C58.9611911,326.157772 62.1105487,319.138431 66.4853049,316.011061 Z" id="p8" fill="url(#linearGradient-12)" opacity="0.345586868" filter="url(#filter-13)" transform="translate(63.437267, 337.502366) rotate(-190.000000) translate(-63.437267, -337.502366) "></path>';

        echo '<g id="g9" transform="translate(30.000000, 13.000000)" stroke-linecap="round">';
        echo '<g id="g10">
                    <use fill="black" fill-opacity="1" filter="url(#filter-15)" xlink:href="#path-14"></use>
                    <use stroke="#FFFFFF" stroke-width="2" xlink:href="#path-14"></use>
                </g>';
        echo '<g id="g11">
                    <use fill="black" fill-opacity="1" filter="url(#filter-15)" xlink:href="#path-16"></use>
                    <use stroke="#FFFFFF" stroke-width="2" xlink:href="#path-16"></use>
                </g>';
        echo '<g id="g12">
                    <use fill="black" fill-opacity="1" filter="url(#filter-15)" xlink:href="#path-18"></use>
                    <use stroke="#FFFFFF" stroke-width="2" xlink:href="#path-18"></use>
                </g>';
        echo '<g id="g13">
                    <use fill="black" fill-opacity="1" filter="url(#filter-15)" xlink:href="#path-20"></use>
                    <use stroke="#FFFFFF" stroke-width="2" xlink:href="#path-20"></use>
                </g>';
        echo '<g id="g14">
                    <use fill="black" fill-opacity="1" filter="url(#filter-15)" xlink:href="#path-22"></use>
                    <use stroke="#FFFFFF" stroke-width="2" xlink:href="#path-22"></use>
                </g>';
        echo '<g id="g15">
                    <use fill="black" fill-opacity="1" filter="url(#filter-15)" xlink:href="#path-24"></use>
                    <use stroke="#FFFFFF" stroke-width="2" xlink:href="#path-24"></use>
                </g>';
        echo '<g id="g16">
                    <use fill="black" fill-opacity="1" filter="url(#filter-15)" xlink:href="#path-26"></use>
                    <use stroke="#FFFFFF" stroke-width="2" xlink:href="#path-26"></use>
                </g>';
        echo '<g id="g17">
                    <use fill="black" fill-opacity="1" filter="url(#filter-15)" xlink:href="#path-28"></use>
                    <use stroke="#FFFFFF" stroke-width="2" xlink:href="#path-28"></use>
                </g>';
        echo '<g id="g18">
                    <use fill="black" fill-opacity="1" filter="url(#filter-15)" xlink:href="#path-30"></use>
                    <use stroke="#FFFFFF" stroke-width="2" xlink:href="#path-30"></use>
                </g>';
        echo '<g id="g19">
                    <use fill="black" fill-opacity="1" filter="url(#filter-15)" xlink:href="#path-32"></use>
                    <use stroke="#FFFFFF" stroke-width="2" xlink:href="#path-32"></use>
                </g>';
        echo '<g id="g20">
                    <use fill="black" fill-opacity="1" filter="url(#filter-15)" xlink:href="#path-34"></use>
                    <use stroke="#FFFFFF" stroke-width="2" xlink:href="#path-34"></use>
                </g>';
        echo '</g>';
        echo '</g>';

        //campaign
        echo '<text class="birdsmeter_campaign" text-anchor="middle" x="188" y="25">'. $therm_properties['campaign'] .'</text>';

        //raised
        if ($therm_properties['show_raised']){
            $per = $therm_properties['raised'] / $therm_properties['target'];
            if ($per > 1){
                $per = 1;
            }
            $y_offset = (305 - 15) * $per;
            echo '<g transform="translate(210,'. strval(310 - $y_offset) .')">';
            echo '<polygon id="po21" fill="#4C87E3" transform="translate(20.000000, 10.000000) rotate(-270.000000) translate(-20.000000, -10.000000) " points="29.5 -10 29.5 30 10.5 -10"></polygon>';
            echo '<polygon id="po22" fill="#1F5BB9" transform="translate(20.000000, 29.000000) scale(1, -1) rotate(-270.000000) translate(-20.000000, -29.000000) " points="29.5 9 29.5 49 10.5 9"></polygon>';
            echo '</g>';
            $raised_text = $therm_properties['currency'] . $this->thermometer_format_number($therm_properties['raised'], $therm_properties['number_format']);
            echo '<text class="birdsmeter_raised" fill="'. $therm_properties['raised_text_color'] .'" text-anchor="start" x="255" y="'. strval(335 - $y_offset) .'">'. $raised_text .'</text>';
        }

        //target
        if ($therm_properties['show_target']){
            $target_text = $therm_properties['currency'] . $this->thermometer_format_number($therm_properties['target'], $therm_properties['number_format']);
            echo '<text class="birdsmeter_target" fill="'. $therm_properties['target_text_color'] .'" text-anchor="end" x="150" y="48">'. $target_text .'</text>';
        }
        echo '</svg>';
        echo '</canvas>';
        if (!$therm_properties['remove_link']){
            echo '</a>';
        }
        echo '</div>';
        return ob_get_clean();
    }

    function thermometer_format_number($number, $number_format){
        $result = '';
        switch ($number_format){
            case '1':
                $result = number_format($number,0,'.','');
                break;
            case '2':
                $result = number_format($number,2,'.','');
                break;
            case '3':
                $result = number_format($number,0,'.',',');
                break;
            case '4':
                $result = number_format($number,2,'.',',');
        }
        return $result;
    }

    function thermometer_generate_mercury_gradient($color){
        $gradient_per = 0.1;
        $value = str_replace('#','',$color);
        $red = hexdec(substr($value,0,2));
        $green = hexdec(substr($value,2,2));
        $blue = hexdec(substr($value,4,2));
        $des_red = 0xff - round($gradient_per * (0xff - $red));
        $des_green = 0xff - round($gradient_per * (0xff - $green));
        $des_blue = 0xff - round($gradient_per * (0xff - $blue));
        $des_color = '#' . str_pad(dechex($des_red),2,'0',STR_PAD_LEFT) . str_pad(dechex($des_green),2,'0',STR_PAD_LEFT) . str_pad(dechex($des_blue),2,'0',STR_PAD_LEFT);
        return [
            'first' => $color,
            'second' => $des_color,
            'third' => $color,
        ];
    }

    function thermometer_generate_mercury_path($target,$raised){
        $per = $raised / $target;
        if ($per > 1){
            $per = 1;
        }
        $y_start = 15;
        $y_end = 305;
        $offset = $per * ($y_end - $y_start);
        $result = 'M42,';
        $result = $result . strval($y_end - $offset) . ' ';
        $result = $result . 'C46,';
        $result = $result . strval($y_end - $offset) . ' ';
        $result = $result . '50,' . strval($y_end - $offset + 3) . ' ';
        $result = $result . '50,' . strval($y_end - $offset + 8) . ' ';
        $result = $result . 'L50,320 L34,320 L34,' .strval($y_end - $offset + 8) . ' ';
        $result = $result . 'C34,' . strval($y_end - $offset + 3) . ' ';
        $result = $result . '37,' . strval($y_end - $offset) . ' ';
        $result = $result . '42,' . strval($y_end - $offset) . ' ';
        $result = $result . 'Z';
        return $result;
    }

    function thermometer_generate_sphere_gradient($color){
        $gradient_per = 0.1;
        $value = str_replace('#','',$color);
        $red = hexdec(substr($value,0,2));
        $green = hexdec(substr($value,2,2));
        $blue = hexdec(substr($value,4,2));
        $start_red = $red + round($gradient_per * (0xff - $red));
        $start_green = $green + round($gradient_per * (0xff - $green));
        $start_blue = $blue + round($gradient_per * (0xff - $blue));
        $start_color = '#' . str_pad(dechex($start_red),2,'0',STR_PAD_LEFT) . str_pad(dechex($start_green),2,'0',STR_PAD_LEFT) . str_pad(dechex($start_blue),2,'0',STR_PAD_LEFT);
        $end_red = $red + 5*round($gradient_per * (0xff - $red));
        $end_green = $green +5* round($gradient_per * (0xff - $green));
        $end_blue = $blue + 5*round($gradient_per * (0xff - $blue));
        $end_color = '#' . str_pad(dechex($end_red),2,'0',STR_PAD_LEFT) . str_pad(dechex($end_green),2,'0',STR_PAD_LEFT) . str_pad(dechex($end_blue),2,'0',STR_PAD_LEFT);
        return [
            'first' => $end_color,
            'second' => $start_color,
        ];
    }
}